<template>
  <div>
    {{ hours | displayTwoDigits }} : {{ minutes | displayTwoDigits }} : {{ seconds | displayTwoDigits }}
  </div>
</template>


<script>
  export default {
    data () {
      return {
        startTime: this.initTime,
        running: false, 
        interval: ''
      }
    },
    filters: {
      displayTwoDigits: (val) => {
        return ("00" + val).slice(-2)
      }
    },
    computed: {
      seconds: function() { return this.startTime % 60 },
      minutes: function() { return (this.startTime - this.seconds ) % 3600 / 60  },
      hours: function() { return (this.startTime - this.minutes * 60  - this.seconds) / 3600}
    },
    props: ['initTime', 'timerId'],
    mounted() {
      this.$root.$on('startTimer-' + this.timerId, () => {
        this.start()
      }),
      this.$root.$on('stopTimer-'+ this.timerId, () => {
        this.stop()
      })
    },
    methods: {
      increaseClock() {
        this.startTime += 1
      },
      start() {
        if(!this.running) {
          this.interval = setInterval(() =>{ this.increaseClock() }, 1000);
        }
        this.running = true
      }, 
      stop() {
       clearInterval(this.interval);
       this.running = false
      }
    }
  }
</script>
